package com.gyee.frame.model.auto;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 *  GyeepermissionExample
 * @author gyee_自动生成
 * @email 1@qq.com
 * @date 2020-04-16 14:55:15
 */
public class GyeepermissionExample {

    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public GyeepermissionExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }
				
        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }
        
			
        public Criteria andPermisssionlevelIsNull() {
            addCriterion("permisssionlevel is null");
            return (Criteria) this;
        }

        public Criteria andPermisssionlevelIsNotNull() {
            addCriterion("permisssionlevel is not null");
            return (Criteria) this;
        }

        public Criteria andPermisssionlevelEqualTo(String value) {
            addCriterion("permisssionlevel =", value, "permisssionlevel");
            return (Criteria) this;
        }

        public Criteria andPermisssionlevelNotEqualTo(String value) {
            addCriterion("permisssionlevel <>", value, "permisssionlevel");
            return (Criteria) this;
        }

        public Criteria andPermisssionlevelGreaterThan(String value) {
            addCriterion("permisssionlevel >", value, "permisssionlevel");
            return (Criteria) this;
        }

        public Criteria andPermisssionlevelGreaterThanOrEqualTo(String value) {
            addCriterion("permisssionlevel >=", value, "permisssionlevel");
            return (Criteria) this;
        }

        public Criteria andPermisssionlevelLessThan(String value) {
            addCriterion("permisssionlevel <", value, "permisssionlevel");
            return (Criteria) this;
        }

        public Criteria andPermisssionlevelLessThanOrEqualTo(String value) {
            addCriterion("permisssionlevel <=", value, "permisssionlevel");
            return (Criteria) this;
        }

        public Criteria andPermisssionlevelLike(String value) {
            addCriterion("permisssionlevel like", value, "permisssionlevel");
            return (Criteria) this;
        }

        public Criteria andPermisssionlevelNotLike(String value) {
            addCriterion("permisssionlevel not like", value, "permisssionlevel");
            return (Criteria) this;
        }

        public Criteria andPermisssionlevelIn(List<String> values) {
            addCriterion("permisssionlevel in", values, "permisssionlevel");
            return (Criteria) this;
        }

        public Criteria andPermisssionlevelNotIn(List<String> values) {
            addCriterion("permisssionlevel not in", values, "permisssionlevel");
            return (Criteria) this;
        }

        public Criteria andPermisssionlevelBetween(String value1, String value2) {
            addCriterion("permisssionlevel between", value1, value2, "permisssionlevel");
            return (Criteria) this;
        }

        public Criteria andPermisssionlevelNotBetween(String value1, String value2) {
            addCriterion("permisssionlevel not between", value1, value2, "permisssionlevel");
            return (Criteria) this;
        }
        
			
        public Criteria andPermisssionnameIsNull() {
            addCriterion("permisssionname is null");
            return (Criteria) this;
        }

        public Criteria andPermisssionnameIsNotNull() {
            addCriterion("permisssionname is not null");
            return (Criteria) this;
        }

        public Criteria andPermisssionnameEqualTo(String value) {
            addCriterion("permisssionname =", value, "permisssionname");
            return (Criteria) this;
        }

        public Criteria andPermisssionnameNotEqualTo(String value) {
            addCriterion("permisssionname <>", value, "permisssionname");
            return (Criteria) this;
        }

        public Criteria andPermisssionnameGreaterThan(String value) {
            addCriterion("permisssionname >", value, "permisssionname");
            return (Criteria) this;
        }

        public Criteria andPermisssionnameGreaterThanOrEqualTo(String value) {
            addCriterion("permisssionname >=", value, "permisssionname");
            return (Criteria) this;
        }

        public Criteria andPermisssionnameLessThan(String value) {
            addCriterion("permisssionname <", value, "permisssionname");
            return (Criteria) this;
        }

        public Criteria andPermisssionnameLessThanOrEqualTo(String value) {
            addCriterion("permisssionname <=", value, "permisssionname");
            return (Criteria) this;
        }

        public Criteria andPermisssionnameLike(String value) {
            addCriterion("permisssionname like", value, "permisssionname");
            return (Criteria) this;
        }

        public Criteria andPermisssionnameNotLike(String value) {
            addCriterion("permisssionname not like", value, "permisssionname");
            return (Criteria) this;
        }

        public Criteria andPermisssionnameIn(List<String> values) {
            addCriterion("permisssionname in", values, "permisssionname");
            return (Criteria) this;
        }

        public Criteria andPermisssionnameNotIn(List<String> values) {
            addCriterion("permisssionname not in", values, "permisssionname");
            return (Criteria) this;
        }

        public Criteria andPermisssionnameBetween(String value1, String value2) {
            addCriterion("permisssionname between", value1, value2, "permisssionname");
            return (Criteria) this;
        }

        public Criteria andPermisssionnameNotBetween(String value1, String value2) {
            addCriterion("permisssionname not between", value1, value2, "permisssionname");
            return (Criteria) this;
        }
        
			
        public Criteria andDescribesIsNull() {
            addCriterion("describes is null");
            return (Criteria) this;
        }

        public Criteria andDescribesIsNotNull() {
            addCriterion("describes is not null");
            return (Criteria) this;
        }

        public Criteria andDescribesEqualTo(String value) {
            addCriterion("describes =", value, "describes");
            return (Criteria) this;
        }

        public Criteria andDescribesNotEqualTo(String value) {
            addCriterion("describes <>", value, "describes");
            return (Criteria) this;
        }

        public Criteria andDescribesGreaterThan(String value) {
            addCriterion("describes >", value, "describes");
            return (Criteria) this;
        }

        public Criteria andDescribesGreaterThanOrEqualTo(String value) {
            addCriterion("describes >=", value, "describes");
            return (Criteria) this;
        }

        public Criteria andDescribesLessThan(String value) {
            addCriterion("describes <", value, "describes");
            return (Criteria) this;
        }

        public Criteria andDescribesLessThanOrEqualTo(String value) {
            addCriterion("describes <=", value, "describes");
            return (Criteria) this;
        }

        public Criteria andDescribesLike(String value) {
            addCriterion("describes like", value, "describes");
            return (Criteria) this;
        }

        public Criteria andDescribesNotLike(String value) {
            addCriterion("describes not like", value, "describes");
            return (Criteria) this;
        }

        public Criteria andDescribesIn(List<String> values) {
            addCriterion("describes in", values, "describes");
            return (Criteria) this;
        }

        public Criteria andDescribesNotIn(List<String> values) {
            addCriterion("describes not in", values, "describes");
            return (Criteria) this;
        }

        public Criteria andDescribesBetween(String value1, String value2) {
            addCriterion("describes between", value1, value2, "describes");
            return (Criteria) this;
        }

        public Criteria andDescribesNotBetween(String value1, String value2) {
            addCriterion("describes not between", value1, value2, "describes");
            return (Criteria) this;
        }
        
			
        public Criteria andRemark1IsNull() {
            addCriterion("remark1 is null");
            return (Criteria) this;
        }

        public Criteria andRemark1IsNotNull() {
            addCriterion("remark1 is not null");
            return (Criteria) this;
        }

        public Criteria andRemark1EqualTo(String value) {
            addCriterion("remark1 =", value, "remark1");
            return (Criteria) this;
        }

        public Criteria andRemark1NotEqualTo(String value) {
            addCriterion("remark1 <>", value, "remark1");
            return (Criteria) this;
        }

        public Criteria andRemark1GreaterThan(String value) {
            addCriterion("remark1 >", value, "remark1");
            return (Criteria) this;
        }

        public Criteria andRemark1GreaterThanOrEqualTo(String value) {
            addCriterion("remark1 >=", value, "remark1");
            return (Criteria) this;
        }

        public Criteria andRemark1LessThan(String value) {
            addCriterion("remark1 <", value, "remark1");
            return (Criteria) this;
        }

        public Criteria andRemark1LessThanOrEqualTo(String value) {
            addCriterion("remark1 <=", value, "remark1");
            return (Criteria) this;
        }

        public Criteria andRemark1Like(String value) {
            addCriterion("remark1 like", value, "remark1");
            return (Criteria) this;
        }

        public Criteria andRemark1NotLike(String value) {
            addCriterion("remark1 not like", value, "remark1");
            return (Criteria) this;
        }

        public Criteria andRemark1In(List<String> values) {
            addCriterion("remark1 in", values, "remark1");
            return (Criteria) this;
        }

        public Criteria andRemark1NotIn(List<String> values) {
            addCriterion("remark1 not in", values, "remark1");
            return (Criteria) this;
        }

        public Criteria andRemark1Between(String value1, String value2) {
            addCriterion("remark1 between", value1, value2, "remark1");
            return (Criteria) this;
        }

        public Criteria andRemark1NotBetween(String value1, String value2) {
            addCriterion("remark1 not between", value1, value2, "remark1");
            return (Criteria) this;
        }
        
			
        public Criteria andRemark2IsNull() {
            addCriterion("remark2 is null");
            return (Criteria) this;
        }

        public Criteria andRemark2IsNotNull() {
            addCriterion("remark2 is not null");
            return (Criteria) this;
        }

        public Criteria andRemark2EqualTo(String value) {
            addCriterion("remark2 =", value, "remark2");
            return (Criteria) this;
        }

        public Criteria andRemark2NotEqualTo(String value) {
            addCriterion("remark2 <>", value, "remark2");
            return (Criteria) this;
        }

        public Criteria andRemark2GreaterThan(String value) {
            addCriterion("remark2 >", value, "remark2");
            return (Criteria) this;
        }

        public Criteria andRemark2GreaterThanOrEqualTo(String value) {
            addCriterion("remark2 >=", value, "remark2");
            return (Criteria) this;
        }

        public Criteria andRemark2LessThan(String value) {
            addCriterion("remark2 <", value, "remark2");
            return (Criteria) this;
        }

        public Criteria andRemark2LessThanOrEqualTo(String value) {
            addCriterion("remark2 <=", value, "remark2");
            return (Criteria) this;
        }

        public Criteria andRemark2Like(String value) {
            addCriterion("remark2 like", value, "remark2");
            return (Criteria) this;
        }

        public Criteria andRemark2NotLike(String value) {
            addCriterion("remark2 not like", value, "remark2");
            return (Criteria) this;
        }

        public Criteria andRemark2In(List<String> values) {
            addCriterion("remark2 in", values, "remark2");
            return (Criteria) this;
        }

        public Criteria andRemark2NotIn(List<String> values) {
            addCriterion("remark2 not in", values, "remark2");
            return (Criteria) this;
        }

        public Criteria andRemark2Between(String value1, String value2) {
            addCriterion("remark2 between", value1, value2, "remark2");
            return (Criteria) this;
        }

        public Criteria andRemark2NotBetween(String value1, String value2) {
            addCriterion("remark2 not between", value1, value2, "remark2");
            return (Criteria) this;
        }
        
			
        public Criteria andParentIsNull() {
            addCriterion("parent is null");
            return (Criteria) this;
        }

        public Criteria andParentIsNotNull() {
            addCriterion("parent is not null");
            return (Criteria) this;
        }

        public Criteria andParentEqualTo(String value) {
            addCriterion("parent =", value, "parent");
            return (Criteria) this;
        }

        public Criteria andParentNotEqualTo(String value) {
            addCriterion("parent <>", value, "parent");
            return (Criteria) this;
        }

        public Criteria andParentGreaterThan(String value) {
            addCriterion("parent >", value, "parent");
            return (Criteria) this;
        }

        public Criteria andParentGreaterThanOrEqualTo(String value) {
            addCriterion("parent >=", value, "parent");
            return (Criteria) this;
        }

        public Criteria andParentLessThan(String value) {
            addCriterion("parent <", value, "parent");
            return (Criteria) this;
        }

        public Criteria andParentLessThanOrEqualTo(String value) {
            addCriterion("parent <=", value, "parent");
            return (Criteria) this;
        }

        public Criteria andParentLike(String value) {
            addCriterion("parent like", value, "parent");
            return (Criteria) this;
        }

        public Criteria andParentNotLike(String value) {
            addCriterion("parent not like", value, "parent");
            return (Criteria) this;
        }

        public Criteria andParentIn(List<String> values) {
            addCriterion("parent in", values, "parent");
            return (Criteria) this;
        }

        public Criteria andParentNotIn(List<String> values) {
            addCriterion("parent not in", values, "parent");
            return (Criteria) this;
        }

        public Criteria andParentBetween(String value1, String value2) {
            addCriterion("parent between", value1, value2, "parent");
            return (Criteria) this;
        }

        public Criteria andParentNotBetween(String value1, String value2) {
            addCriterion("parent not between", value1, value2, "parent");
            return (Criteria) this;
        }
        
			
        public Criteria andIsableIsNull() {
            addCriterion("isable is null");
            return (Criteria) this;
        }

        public Criteria andIsableIsNotNull() {
            addCriterion("isable is not null");
            return (Criteria) this;
        }

        public Criteria andIsableEqualTo(String value) {
            addCriterion("isable =", value, "isable");
            return (Criteria) this;
        }

        public Criteria andIsableNotEqualTo(String value) {
            addCriterion("isable <>", value, "isable");
            return (Criteria) this;
        }

        public Criteria andIsableGreaterThan(String value) {
            addCriterion("isable >", value, "isable");
            return (Criteria) this;
        }

        public Criteria andIsableGreaterThanOrEqualTo(String value) {
            addCriterion("isable >=", value, "isable");
            return (Criteria) this;
        }

        public Criteria andIsableLessThan(String value) {
            addCriterion("isable <", value, "isable");
            return (Criteria) this;
        }

        public Criteria andIsableLessThanOrEqualTo(String value) {
            addCriterion("isable <=", value, "isable");
            return (Criteria) this;
        }

        public Criteria andIsableLike(String value) {
            addCriterion("isable like", value, "isable");
            return (Criteria) this;
        }

        public Criteria andIsableNotLike(String value) {
            addCriterion("isable not like", value, "isable");
            return (Criteria) this;
        }

        public Criteria andIsableIn(List<String> values) {
            addCriterion("isable in", values, "isable");
            return (Criteria) this;
        }

        public Criteria andIsableNotIn(List<String> values) {
            addCriterion("isable not in", values, "isable");
            return (Criteria) this;
        }

        public Criteria andIsableBetween(String value1, String value2) {
            addCriterion("isable between", value1, value2, "isable");
            return (Criteria) this;
        }

        public Criteria andIsableNotBetween(String value1, String value2) {
            addCriterion("isable not between", value1, value2, "isable");
            return (Criteria) this;
        }
        
	}

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}